DroidAR
=======

DroidAR is a framework for Augmented Reality on Android. Location based AR and marker based AR are both possible.
Also read the [wiki articles](https://github.com/bitstars/droidar/wiki/_pages) (or the [FAQ](https://github.com/bitstars/droidar/wiki/FAQ)) for more detailed information about DroidAR.

This framework can be used for many different scenarios, there are already some demo applications available (check the videos below).
For the latest news about DroidAR also visit our [blog](http://droidar.blogspot.com/).

DroidAR is available under commercial license (contact us http://http://bitstars.com/about/team/ for more details) and can be downloaded and used for non commercial use under the GNU GPL v3 ( http://www.gnu.org/licenses/gpl.html ) license.

Contributing to the code
=======
I would be great if you want to help working on the code, fixing bugs, refactorings and adding you own ideas. Contributing to DroidAR is easy on GitHub (that's the main reason why we switched from Google Code). 

1. Click "Fork", check out your fork and do your changes in your local copy of DroidAR 
2. When you are done commite all changes to you online copy 
3. Send a Pull-Request to via the Github webpage ([see Pull-Requests for more infos](https://help.github.com/articles/using-pull-requests)). 
4. I will review your changes and merge them in the main repository so that everyone can use them.

There are some rules to allow an easy integration of your code and changes:

- You have to use the default code formatting style of Eclipse
- You should enable auto formatting whenever you save a file. This way you can't forget to format: Go to Preferences->Java->Editor->Save Actions and enable "Format source code" and "Organize imports". 

Now when you save the code is formatted automatically. This will avoid commit conflicts and changes in the code can be reviewed more easily. 


Demo Videos
=======

<a href="http://www.youtube.com/watch?feature=player_embedded&v=v2zyj9hPiDo
" target="_blank"><img src="http://img.youtube.com/vi/v2zyj9hPiDo/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>

<a href="http://www.youtube.com/watch?feature=player_embedded&v=8GtVcQN0CpY
" target="_blank"><img src="http://img.youtube.com/vi/8GtVcQN0CpY/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>
<a href="http://www.youtube.com/watch?feature=player_embedded&v=brlNkKmw8IY
" target="_blank"><img src="http://img.youtube.com/vi/brlNkKmw8IY/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>
<a href="http://www.youtube.com/watch?feature=player_embedded&v=e0Xc00Csrg0
" target="_blank"><img src="http://img.youtube.com/vi/e0Xc00Csrg0/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>
<a href="http://www.youtube.com/watch?feature=player_embedded&v=w5BrHLnG4no
" target="_blank"><img src="http://img.youtube.com/vi/w5BrHLnG4no/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>
<a href="http://www.youtube.com/watch?feature=player_embedded&v=FH9vJ684j_U
" target="_blank"><img src="http://img.youtube.com/vi/FH9vJ684j_U/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>
<a href="http://www.youtube.com/watch?feature=player_embedded&v=fEd0HORzStQ
" target="_blank"><img src="http://img.youtube.com/vi/fEd0HORzStQ/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>


Details
=======

Location based AR and marker based AR are both possible. This framework can be used for many different scenarios, there are already some demo applications available.
- Footstep recognition & Indoor AR
- Locationbased Gaming & Crowdsourcing Framework

Since the initial creation of the prototype of an augmented reality development tool in 2010, it was continuously improved and new features were added. The created development tool (SDK) enables other programmers to integrate augmented reality in their own applications.
We provided the SDK without charge with an Open Source License for non-commercial projects. It has since evolved into one of the most used open source augmented reality SDKs for the Android platform. The regular feedback from the developers as well as its application in seminars and practical project seminars, where the SDK was used as basis for their projects, greatly aided its improvement. The framework meets and raises interests and is currently being used by numerous developers around the globe. The recorded numbers of the site are about 1500 website visits per month with an increasing tendency. Also, 83% of the about 3200 developers return to the website following their initial visit.

Also take a look at the [DroidAR FAQ](https://github.com/bitstars/droidar/wiki/FAQ) and the other [Wiki pages](https://github.com/bitstars/droidar/wiki/_pages)

Installation
=======
A new instructions video is comming soon. You can watch the old one here:

<a href="http://www.youtube.com/watch?feature=player_embedded&v=MFbEvkWJOV0
" target="_blank"><img src="http://img.youtube.com/vi/MFbEvkWJOV0/0.jpg" 
alt="Link to the DroidAR video" width="240" height="180" border="10" /></a>

[![githalytics.com alpha](https://cruel-carlota.pagodabox.com/b0e941873eef1822c01f7ce9e5296630 "githalytics.com")](http://githalytics.com/bitstars/droidar)

Applications using DroidAR
=======
(If you use DroidAR in your application you can write us a mail to be added hiere)

<a href="https://play.google.com/store/apps/details?id=com.thoughtshastra.templetreasure" 
target="_blank"><img src="https://lh3.ggpht.com/6s2gdlZZPh80h7QvDc6JD7Y4nF3ap3EjrZ_pqrRKhho7XuJpcKBOC94mYN27M54jIXQS=h900-rw" 
alt="Temple Treasure" width="240" height="150" border="10" /></a>
   
<a href="https://play.google.com/store/apps/details?id=de.interactivepioneers.chioapp&hl=en
" target="_blank"><img src="https://lh6.ggpht.com/cQL1gDDzcvwoiS1tqBA8MVWD2i98RfcZnbq1ZKWgf_ei-qb0_MSFAoKgk7RA6BMKjjs=w300-rw" 
alt="CHIO Aachen" width="150" height="150" border="10" /></a>
